#include <stdio.h>
#include <math.h>
#include <time.h>
#define N 15
#define TULP 2

int array(int, int, int[][N]);
void calc(int[][N], int[], int, int);
void sort(int[], int);
void output(int[], int);

int main(void)
{
    int n, m, A[N][N];
    int korrutis[N];

    do
    {
        printf("Sisesta n: ");
        scanf("%d", &n);
        printf("Sisesta m: ");
        scanf("%d", &m);
    }while(n < 1 && n > 15 && m < 1 && m > 15);

    array(n, m, A);
    calc(A, korrutis, n, m);
    sort(korrutis, n);
    output(korrutis, n);

    return 0;
}

int array(int n, int m, int A[N][N])
{
    char choice;
    int i, j;

    printf("Kas tahad, et programm taidaks ise maatriksi(1 means no, 0 means yes)? \n");
    scanf("%d", &choice);

    if(choice == 0)
    {
        for(i = 0; i < n; i++)
        {
            for(j = 0; j < m; j++)
            {
                A[i][j] = rand() % 99 + 1;
            }
        }
    }

    else
    {
        for(i = 0; i < n; i++)
        {
            for(j = 0; j < m; j++)
            {
                printf("Sisesta A kohal [%d][%d] ", i, j);
                scanf("%d", &A[i][j]);
            }
        }
    }
    return A;
}

void calc(int A[N][N], int korrutis[N], int n, int m)
{
    int i, j;

    for(i = 0; i < n; i++)
    {
        for(j = 1; j < TULP; j++)
        {
            korrutis[i] = A[i][j] * A[i][j-1];
        }
    }
}

void sort(int korrutis[N], int n)
{
    int i, vahem;
    int sorted = 0;

    while(!sorted)
    {
        sorted = 1;
        for(i = 0; i < n; i++)
        {
            if(korrutis[i] < korrutis[i + 1])
            {
                vahem = korrutis[i];
                korrutis[i] = korrutis[i + 1];
                korrutis[i + 1] = vahem;
                sorted = 0;
            }
        }
    }
}

void output(int korrutis[N], int n)
{
    int i;

    for(i = 0; i < n; i++)
    {
        printf("korrutis %d: %d \n", i+1, korrutis[i]);
    }
}
